#include <bits/stdc++.h>
using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int int64_t

void solve() {
    string l, r; cin >> l >> r;
    for (int i = l.size() - 1; i >= 0; i--) {
        if (l[i] >= '1') {
            l[i]--;
            break;
        }
        l[i] = '9';
    }
    auto f = [&](string mx) -> int {
        vector<vector<vector<int>>> dp(mx.size() + 1, vector<vector<int>>(2, vector<int>(2)));
        vector<vector<int>> dp2(mx.size(), vector<int>(2));
        int n = mx.size();
        //dp[i][j][k]
        // i - размер
        // j - совпадает ли префикс
        // k - есть ли уже не 1
        dp[0][1][0] = 1;
        dp2[0][0] = 1;
        int ans = 0;
        for (int i = 1; i <= mx.size(); i++) {
            for (char c = '0'; c <= '9'; c++) {
                if (c == '0' || c == '4' || c == '6' || c == '8' || c == '9') {
                    continue;
                }
                if (c == mx[i - 1]) {
                    if (c != '1') {
                        dp[i][1][1] += dp[i - 1][1][0];
                    }
                    if (c == '1') {
                        dp[i][1][0] += dp[i - 1][1][0];
                        dp[i][1][1] += dp[i - 1][1][1];
                    }
                }
                if (c != '1') {
                    if (c < mx[i - 1]) {
                        dp[i][0][1] += dp[i - 1][1][0];
                    }
                    dp[i][0][1] += dp[i - 1][0][0];
                } else {
                    if (c < mx[i - 1]) {
                        dp[i][0][0] += dp[i - 1][1][0];
                        dp[i][0][1] += dp[i - 1][1][1];
                    }
                    dp[i][0][1] += dp[i - 1][0][1];
                    dp[i][0][0] += dp[i - 1][0][0];
                }
                if (i == mx.size()) continue;
                if (c == '1') {
                    dp2[i][0] += dp2[i - 1][0];
                    dp2[i][1] += dp2[i - 1][1];
                } else {
                    dp2[i][1] += dp2[i - 1][0];
                }
            }
            if (i < mx.size()) {
                ans += dp2[i][1];
            }
        }
        return dp[n][0][1] + dp[n][1][1] + ans;
    };
    cout << f(r) - f(l);
    // cout << f(r);
}

int32_t main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}