#include <bits/stdc++.h>

#define int int64_t

using namespace std;

struct sgt {
    vector<int> t;
    void build(int v, int l, int r, const vector<int>& a) {
        if (r - l == 1) {
            t[v] = a[l];
            return;
        }
        int m = l + r >> 1;
        build(2 * v + 1, l, m, a);
        build(2 * v + 2, m, r, a);
        t[v] = max(t[2 * v + 1], t[2 * v + 2]);
    }
    int get(int v, int l, int r, int ql, int qr) {
        if (l >= ql && r <= qr) return t[v];
        if (l >= qr || ql >= r) return -1e18;
        int m = l + r >> 1;
        return max(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
    }

    explicit sgt(const vector<int>& a) {
        int n = a.size();
        t.resize(4 * n);
        build(0, 0, a.size(), a);
    }
};

void solve() {
    int n, k; cin >> n >> k;
    vector<int> a(n);
    for (auto& x : a) cin >> x;
    vector<int> prefmn(n, a[0]), suffmn(n, a[n-1]);
    for (int i = 1; i < n; ++i) {
        prefmn[i] = max(prefmn[i - 1], a[i]);
    }
    for (int i = n - 2; i >= 0; --i) {
        suffmn[i] = max(suffmn[i + 1], a[i]);
    }
    vector<int> p(n + 1, 0);
    partial_sum(a.begin(), a.end(), 1 + p.begin());
    if (k == 2) {
        int l = 0, r = n - k;
        int mx = 0;
        while (r < n) {
            int mn = p[r + 1] - p[l];
            if (l > 0) mn = min(mn, prefmn[l - 1]);
            if (r < n - 1) mn = min(mn, suffmn[r + 1]);
            mx = max(mx, p[r + 1] - p[l] - mn);
            l++;
            r++;
        }
        cout << mx;
        return;
    }
    if (k == 3) {
        int mx = 0;
        for (int i = 1; i < n - 1; ++i) {
            mx = max(mx, max({p[i], p[n] - p[i + 1], a[i]}) - min({p[i], p[n] - p[i + 1], a[i]}));
        }
        mx = max(mx, max({p[n - 1] - p[1], a[0], a[n - 1]}) - min({p[n - 1] - p[1], a[0], a[n - 1]}));
        cout << mx;
        return;
    }
    int aaans = 0;
    vector<int> precalc(n);
    for (int i = 0; i < n; ++i) {
        precalc[i] = p[i + 1] - p[max<int>(0, i - n + k)];
    }
    vector<int> prefmax(n, precalc[0]);
    for (int i = 1; i < n; ++i) {
        prefmax[i] = max(prefmax[i - 1], precalc[i]);
    }
    sgt sgt(precalc);
    for (int i = 0; i < n; ++i) {
        //пусть a[i] будет подмножество с мин суммой
        int r = 0;
        int ans = 0;
        if (i > 0) ans = prefmax[i - 1] - a[i];
        // r = i + 1;
        // while (r < n) {
        //     int mx = p[r + 1] - p[max<int>(i + 1, r - n + k)];
        //     ans = max(ans, mx - a[i]);
        //     r++;
        // }
        ans = max(ans, p[max(i + 1, min(n, n + i - k + 1))] - p[i + 1] - a[i]);
        if (n + i - k + 1 < n) ans = max(ans, sgt.get(0, 0, n, n + i - k + 1, n) - a[i]);
        aaans = max(aaans, ans);
    }
    cout << aaans;
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}