#pragma GCC optimize("O3, unroll-loops")
#pragma GCC target("avx2")
#include <bits/stdc++.h>

#define int int64_t

using namespace std;

void solve() {
    int n, k; cin >> n >> k;
    vector<int> a(n);
    for (auto& x : a) cin >> x;
    vector<int> prefmn(n, a[0]), suffmn(n, a[n-1]);
    for (int i = 1; i < n; ++i) {
        prefmn[i] = max(prefmn[i - 1], a[i]);
    }
    for (int i = n - 2; i >= 0; --i) {
        suffmn[i] = max(suffmn[i + 1], a[i]);
    }
    vector<int> p(n + 1, 0);
    partial_sum(a.begin(), a.end(), 1 + p.begin());
    if (k == 2) {
        int l = 0, r = n - k;
        int mx = 0;
        while (r < n) {
            int mn = p[r + 1] - p[l];
            if (l > 0) mn = min(mn, prefmn[l - 1]);
            if (r < n - 1) mn = min(mn, suffmn[r + 1]);
            mx = max(mx, p[r + 1] - p[l] - mn);
            l++;
            r++;
        }
        cout << mx;
        return;
    }
    if (k == 3) {
        int mx = 0;
        for (int i = 1; i < n - 1; ++i) {
            mx = max(mx, max({p[i], p[n] - p[i + 1], a[i]}) - min({p[i], p[n] - p[i + 1], a[i]}));
        }
        mx = max(mx, max({p[n - 1] - p[1], a[0], a[n - 1]}) - min({p[n - 1] - p[1], a[0], a[n - 1]}));
        cout << mx;
        return;
    }
    int aaans = 0;
    vector<int> precalc(n);
    for (int i = 0; i < n; ++i) {
        precalc[i] = p[i + 1] - p[max<int>(0, i - n + k)];
    }
    vector<int> prefmax(n, precalc[0]);
    for (int i = 1; i < n; ++i) {
        prefmax[i] = max(prefmax[i - 1], precalc[i]);
    }
    for (int i = 0; i < n; ++i) {
        //пусть a[i] будет подмножество с мин суммой
        int r = 0;
        int ans = 0;
        if (i > 0) ans = prefmax[i - 1] - a[i];
        r = i + 1;
        while (r < n) {
            int mx = p[r + 1] - p[max<int>(i + 1, r - n + k)];
            ans = max(ans, mx - a[i]);
            r++;
        }
        aaans = max(aaans, ans);
    }
    cout << aaans;
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}