#include <bits/stdc++.h>

#define int int64_t

using namespace std;

struct sgt {
    vector<int> t;
    void build(int v, int l, int r, const vector<int>& a) {
        if (r - l == 1) {
            t[v] = a[l];
            return;
        }
        int m = l + r >> 1;
        build(2 * v + 1, l, m, a);
        build(2 * v + 2, m, r, a);
        t[v] = min(t[2 * v + 1], t[2 * v + 2]);
    }
    int get(int v, int l, int r, int ql, int qr) {
        if (l >= ql && r <= qr) return t[v];
        if (l >= qr || ql >= r) return 1e18;
        int m = l + r >> 1;
        return min(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
    }

    explicit sgt(const vector<int>& a) {
        int n = a.size();
        t.resize(4 * n);
        build(0, 0, a.size(), a);
    }
};

void solve() {
    int n, s; cin >> n >> s;
    vector<vector<int>> v(n);
    for (int i = 0; i < n; ++i) {
        int k; cin >> k;
        v[i].resize(k);
        for (auto& x : v[i]) cin >> x;
    }
    if (n == 1) {
        bitset<100001> bs;
        bs[0] = true;
        vector<int> frst(1e5 + 1, -1);
        for (int i = 0; i < v[0].size(); ++i) {
            auto h =(bs ^ (bs | (bs << v[0][i])));
            for (int j = h._Find_first(); j < h.size(); j = h._Find_next(j))
                frst[j] = i;
            bs = bs ^ h;
        }
        if (!bs[s]) {
            cout << "NO\n";
            return;
        }
        cout << "YES\n";
        vector<int> ans;
        for (int i = frst[s]; i >= 0; i = frst[s]) {
            ans.push_back(i + 1);
            s -= v[0][i];
        }
        cout << ans.size() << '\n';
        for (auto& x : ans) cout << x << ' ';
    }
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}